#include <iostream>
#include <cmath>
#include <sstream>
#include <fstream>
#include <cstdlib>
#include "miscelous.h"
#include "domain.h"
#include "interaction.h"
using namespace std;


int main( int argc, char *argv[] ) {

/***********************************
***      Citanie argumentov      ***
***********************************/

/* 
stringstream ss(argv[1]);
ss >> n; */


char * argp1 = new char [50];
char * argp2 = new char [50];

int in_filearg=0;
for (int i=1; i<argc; i++) {
 if (argv[i][0]=='-') {
 //long GNU options //----------------------------------------->
  if (argv[i][1]=='-') {
   int j=2;
   while (argv[i][j]!='='&&argv[i][j]!='\0'){
    argp1[j-2]=argv[i][j];
    j++;
    };
   if (argv[i][j]=='=') {
    while (argv[i][j]!='\0'){
     argp2[j-2]=argv[i][j];
     j++;
     };
   };
   if (compargs(argp1,"help")) {
     cout << "Usage: neutron [options] input_file" << endl;
     exit (0);
     } else {
     cerr << argv[0] << ": Unknown option: " << argp1 << endl;
     exit (1);
     };
    } else {
   //shrot options ------------------------------------------->
   for (int j=1;argv[i][j]!='\0';j++) {
    switch (argv[i][j]) {
     case 'v':
      cout << "I am in verbose mode" << endl;
      break;
     case 'h':
      cout << "Usage: neutron [options] input_file" << endl;
      exit (0);
      break;
     default:
       cerr << argv[0] << "Unknown option: " << argv[i][j] << endl;
       exit (1);
     };
    }; 
   }; 
  } else {
//obligatory argument - input ------------------------------------->
  in_filearg=i;
  };
 };
delete [] argp1;
delete [] argp2;
if (in_filearg==0) {
 cerr << argv[0] << ": No file specified";
 exit (1);
 };
ifstream vstup(argv[in_filearg]);

/******************************************
***          citanie vstupu             ***
******************************************/

int a=10
int x,y,z,n=0,m=0;
int n_domain=0,m_interact=0;
int nsteps=10;
int out_domains=0;
double d=0,co,r,c;
double dt=1,counter=0;
char type[50];
char * cislo = new char [50];

domain ** pole;
interaction ** vztah;
char * prikaz = new char [50];
stringstream * ss;

while (vstup >> prikaz) {
 cout << "Reading " << prikaz << endl;
 if (compargs(prikaz,"end")) {
  cout << "Starting calculation!" << endl;
  break;
/*  } else if (compargs(prikaz,"!")) {
   cout << "comentary ignored"; */
  } else if (compargs(prikaz,"start")) {
   vstup >> n_domain >> m_interact;
   cout << "Starting program" << endl;
   cout << "number of domains is "<< n_domain
        <<" number of interactions is "<< m_interact << endl;
   pole = new domain * [n_domain];
   vztah = new interaction * [m_interact];
  } else if (compargs(prikaz,"steps")) {
   vstup >> nsteps;
  } else if (compargs(prikaz,"domain")) {
   n++;
   cout << "values for domain number " << n <<":"<<endl; 
   vstup >> x >> y >> z;
   pole[n] = new domain(x,y,z);
   cout << "size of matrix: " << pole[n]->size() << endl;
   cout << x << " " << y << " " << z << endl << endl;
   for (int i=1;i<=z;i++) {
    for (int j=1;j<=y;j++) {
     for (int k=1; k<x;k++) {
      vstup.getline(cislo,50,' ');
      cout << "cislo=" << cislo << endl;
      ss = new stringstream(cislo);
      cout << '*';
      *ss >> c;
      cout << k <<" "<< j <<" "<< i <<" "<< c << endl;
      pole[n]->setValue(k,j,i,c);
      delete ss;
      };
     vstup.getline(cislo,50);
     ss = new stringstream(cislo);
     *ss >> c;
     cout << '*';
     pole[n]->setValue(x,j,i,c);
     cout << x <<" "<< j <<" "<< i <<" "<< c << endl;
     delete ss;
     };
     cout << endl;
    };
    cout << "done reading matrix" << endl;
  } else if (compargs(prikaz,"interaction")) {
   m++;
   //domain 1, domain 2
   vstup >> x >> y;
   vztah[m] = new interaction(pole[x],pole[y]); 
   vstup >> type;
   vztah[m]->setType(type);
   switch (vztah[m]->showType()) {
    case 1:
     vstup >> d >> co;
     vztah[m]->setParams(d,co);
     break;
    case 2:
     vstup >> d >> co >> r;
     vztah[m]->setParams(d,co,r);
     break;
    case 3:
     cerr << "interaction 'transmit' not implemented yet" << endl;
    default:
     cerr << "unknown type of interaction" << endl;
    };
   cout << "interaction " << m << " has type " << vztah[m]->showType() << endl;
  } else if (compargs(prikaz,"outonly")) {
   vstup >> out_domains;
  };
};

if (out_domains==0) out_domains=n;


/************************************
***     Vypoctova cast programu   ***
************************************/

for (int i=1;i<=n;i++) pole[i]->wright(); 

for (int i=1;i<=nsteps;i++) {
 counter+=dt;
 cout << "time " << counter << endl;
 for (int j=1;j<=m;j++) {
  vztah[j]->step(dt);
  };
 //plutie outputu
 for (int f=1;f<=out_domains;f++) {
  cout << "domain " << f << " size x=" << pole[f]->sizeX()
                         << " size y=" << pole[f]->sizeY()
                         << " size z=" << pole[f]->sizeZ()
                         << endl;
  pole[f]->wright();
  };
 };

//for (int i=1;i<=n;i++) delete [] pole;
//for (int i=1;i<=m;i++) delete [] vztah;

return 0;
}
